Attribute VB_Name = "modDelcares"
'===========================================================================
'
' Module Name:  modDeclares
' Author:       Slider
' Date:         29/05/01
' Version:      01.00.00
' Description:  API Declarations and reusable code units
' Edit History: 01.00.00 29/05/01 Initial Release
'
'===========================================================================

Option Explicit

Public Type RECT
    Left     As Long
    Top      As Long
    Right    As Long
    Bottom   As Long
End Type

Type POINTAPI  '  8 Bytes
    X As Long
    Y As Long
End Type

Public Type Size
    cx As Long
    cy As Long
End Type

Public Declare Function winSetFocus Lib "user32" Alias "SetFocus" (ByVal hWnd As Long) As Long
Public Declare Function winGetFocus Lib "user32" Alias "GetFocus" () As Long

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Function SetParent& Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long)
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

' Focus and activation functions
Public Const GWL_STYLE = (-16)
Public Const WS_CHILD = &H40000000

' SetWindowPos Flags
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOREDRAW = &H8
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_FRAMECHANGED = &H20
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_HIDEWINDOW = &H80
Public Const SWP_NOCOPYBITS = &H100
Public Const SWP_NOOWNERZORDER = &H200

Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
Public Const HWND_TOP = 0
Public Const HWND_BOTTOM = 1
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long

Public Declare Function CreateDCAsNull Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, lpDeviceName As Any, lpOutput As Any, lpInitData As Any) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long

' Rectangle functions:
Public Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Public Declare Function EqualRect Lib "user32" (lpRect1 As RECT, lpRect2 As RECT) As Long
Public Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal ptX As Long, ByVal ptY As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hbrush As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long

' Background Modes
Public Const TRANSPARENT = 1
Public Const OPAQUE = 2
Public Const BKMODE_LAST = 2

' Pen Styles
Public Const PS_SOLID = 0
Public Const PS_DASH = 1                    '  -------
Public Const PS_DOT = 2                     '  .......
Public Const PS_DASHDOT = 3                 '  _._._._
Public Const PS_DASHDOTDOT = 4              '  _.._.._
Public Const PS_NULL = 5
Public Const PS_INSIDEFRAME = 6
Public Const PS_USERSTYLE = 7
Public Const PS_ALTERNATE = 8
Public Const PS_STYLE_MASK = &HF

Public Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Public Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function SetTextAlign& Lib "gdi32" (ByVal hdc As Long, ByVal wFlags As Long)
Public Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long
Public Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long
Public Declare Function SetTextCharacterExtra Lib "gdi32" (ByVal hdc As Long, ByVal nCharExtra As Long) As Long
Public Declare Function SetTextJustification Lib "gdi32" (ByVal hdc As Long, ByVal nBreakExtra As Long, ByVal nBreakCount As Long) As Long
Public Declare Function GetTextExtentPoint32& Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As Size)

Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function ExtCreatePen Lib "gdi32" (ByVal dwPenStyle As Long, ByVal dwWidth As Long, lplb As LOGBRUSH, ByVal dwStyleCount As Long, lpStyle As Long) As Long

Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Public Declare Function GetCurrentPositionEx Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI) As Long
Public Declare Function StrokePath Lib "gdi32" (ByVal hdc As Long) As Long

Private Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Private Const LOGPIXELSY = 90    '  Logical pixels/inch in Y

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long

Private Const LF_FACESIZE = 32

Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700
Private Const FF_DONTCARE = 0
Private Const DEFAULT_QUALITY = 0
Private Const DEFAULT_PITCH = 0
Private Const DEFAULT_CHARSET = 1

Public Type LOGFONT
   lfHeight As Long ' The font size (see below)
   lfWidth As Long ' Normally you don't set this, just let Windows create the Default
   lfEscapement As Long ' The angle, in 0.1 degrees, of the font
   lfOrientation As Long ' Leave as default
   lfWeight As Long ' Bold, Extra Bold, Normal etc
   lfItalic As Byte ' As it says
   lfUnderline As Byte ' As it says
   lfStrikeOut As Byte ' As it says
   lfCharSet As Byte ' As it says
   lfOutPrecision As Byte ' Leave for default
   lfClipPrecision As Byte ' Leave for default
   lfQuality As Byte ' Leave for default
   lfPitchAndFamily As Byte ' Leave for default
   lfFaceName(LF_FACESIZE) As Byte ' The font name converted to a byte array
End Type

Type LOGBRUSH     '  12 Bytes
     lbStyle As Long
     lbColor As Long
     lbHatch As Long
End Type

Public Type DRAWTEXTPARAMS
    cbSize        As Long
    iTabLength    As Long
    iLeftMargin   As Long
    iRightMargin  As Long
    uiLengthDrawn As Long
End Type

Public Type TEXTMETRIC   '  53 Bytes
        tmHeight           As Long
        tmAscent           As Long
        tmDescent          As Long
        tmInternalLeading  As Long
        tmExternalLeading  As Long
        tmAveCharWidth     As Long
        tmMaxCharWidth     As Long
        tmWeight           As Long
        tmOverhang         As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar        As Byte
        tmLastChar         As Byte
        tmDefaultChar      As Byte
        tmBreakChar        As Byte
        tmItalic           As Byte
        tmUnderlined       As Byte
        tmStruckOut        As Byte
        tmPitchAndFamily   As Byte
        tmCharSet          As Byte
End Type

Public Enum eTextFlags
    DT_TOP = &H0
    DT_LEFT = &H0
    DT_CENTER = &H1
    DT_RIGHT = &H2
    DT_VCENTER = &H4
    DT_BOTTOM = &H8
    DT_WORDBREAK = &H10
    DT_SINGLELINE = &H20
    DT_EXPANDTABS = &H40
    DT_TABSTOP = &H80
    DT_NOCLIP = &H100
    DT_EXTERNALLEADING = &H200
    DT_CALCRECT = &H400
    DT_NOPREFIX = &H800
    DT_INTERNAL = &H1000
    DT_EDITCONTROL = &H2000
    DT_PATH_ELLIPSIS = &H4000
    DT_END_ELLIPSIS = &H8000
    DT_MODIFYSTRING = &H10000
    DT_RTLREADING = &H20000
    DT_WORD_ELLIPSIS = &H40000
End Enum

Public Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pccolorref As Long) As Long
Public Const CLR_INVALID = -1

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
                   
Private Const WM_SETREDRAW = &HB

Public Function LockControl(objX As Object, cLock As Boolean)

   If cLock Then
      ' Disable the Redraw flag for the specified window
      Call SendMessage(objX.hWnd, WM_SETREDRAW, False, 0)
   Else
      ' Enable the Redraw flag for the specified window, and repaint
      Call SendMessage(objX.hWnd, WM_SETREDRAW, True, 0)
      objX.Refresh
   End If

End Function

Public Sub Ce tmL, WM_S_WORDRAW, True, 0 P_WORDRAW, Trueefresh
   End IFOthe spCn  DT_RTLng
PS(ByVnulDT_RTLng
PS(ByVnulDT,NRTLng
PS(ByVnulDT_RTLng
PS(ByVnulDT,NVnuc Declare Function StrokePath Lib "ByVnulDT_RTLng
P LineTo Lib "gdi32" (BS(ByVnur  A'RTLnTLng
are Function StrokMessage(objX.hWnd,ZAs 
Privatsaglare Fun!NOCLIP = &H100re Funic Ds LoFsT_RTLng
PS(ByVnulDT,NRTLng
PS(ByVnulDTK sing, ByVal lParam As Long) As LongCare Fun!NOCe tongAs )iO        As Long
     PgAs t &Hawthe-sz As GE4PgAs t &HaK = &H10
    DT_SINGLsmgaZAs 
P LongCared    Rong) As LongCLIP = &H100re FuongCared  e Fun!NOCvhg
are FunctioXmall   'T
arePgAByte ' As itrxter        As Long
  TLng
PCeNaongong) As LonTH40
    DTrcgongGg
PCc Fun!NOCvhg
Pub&lNaongong) AsnBra1
gGg
TH40
bongons Longgong) AsnBgongGgde tHnlLT_TABI00re Funaared  e FuuA" (ByVaLib "gdi32" ( Longgong) AsnBgongGgde tHnlLT_TABI0st DE
P LonceName(LF_FACESIZE) AsnBgob         As Long
        tmOverv As Lon        tmOverv As L2TH40
&verv BeNaabrTgongGgde tH(DeleteObjects L2TPARAMS) As Long
S) As Long
S)As VLong
S) As Long
ST AllPub&lNaongong) AsnBra1
gGg
TH40
bongons Longgong) AsnBgongGgde tHnlLT_TABI00rong)X(ByLaonge tHnlLTAdeteOLonga)
jL = PS_ALTERNATE =0eBXspecifl.EoAecifl LonceName(LOAs V Eng, ByVaeBXspecifl.EoAecifl LonceNgkAs Lon   u Fdvifl tylong
        vMfor the specifAsnBfcde tH(Deletue Tylong
        vMLong
        aXoLausnBfcde tH(Deletue Tylon
  c As Long,tue Tn
  c As Long,tue TETylong
.EoAecenalLeading  Asl MTn
  c As Long,tue    &l MTn
  c As Log,tue    &l MTn
  c
.Eol0rpBOgE =INTn
  c A AshwParamu,tue Tn
  c As Long,ts Log,tue    &l MTn
  c
.EE
     PgAa
  Atte, Bl1a, cLock  mE =INTn mE =INTuA,tue    &l M
  c
.EE mED.hWnd, WM_SETREDRAW, TrA As As Log,tuev TrA hWnd,     tMTn
  c
.EE
eAs nr hWnuptLutOgE =INTn
  c A AshwParamu,tue Tn
  c As Long,tTLontueLn MTn
  ETREDRAW, TrA As AsN=INeed    ,tuev TrA hWnd,  onghtTLontueLn MTn
  ETREDRAW, TrA As AsN=INeed ,000000n
  ontueLn MTn
A TrA A(&bFbRTLng
PS(ByVnulDT,NRTLng
PS(ByVnulDTK sing, B ong) Asv-ByVal nIndex Ass0sN=Tn
 v-ByVal nIndex Ass0sNi
d ,.iAeLong
     e Rare FunctTn
  c
.EE
eAsaTEX
     W, TLn
  c
.EE
eAsaTEAss0
   lfCharSet TLnte  tmHevMLong
    yVnulDT,NRTLng
PS(BXeoXELef As Long) As Long
Public CooXELef AW As Long
Publ8t1

Public s0sNi
d ,.iAeLong
xublP-eL.rX DC'
  c
.EE
eAsaTEX t TLnte a   RongSic Declare FuegaTEX
    tm As Long
Public CooXELef AW As Long
PubltnulDT,NRTLnC'
ublic CAW As Lon)ilpStyle As  Long
        tmWeigB   tm As LAvle As  Long
        tmKMtm 7e
 e0ne2Vse tHnl0D.OwCharSet s
 2Vse tHnl0D.OwCharSet s
 2Vse tHnharSet sg&sRu yle As  Long
      As Long
PLe-as
 2Vse tHnl0D.OwCharSwOdng
    yVnulDTltnulDT,SwOdng
    yVnulDTltuality As Bye As A As Long, ByVal 2Vsedng
  AQu
  FunngicSse tHl AQu
  FunngicSse tHl AQu
  FunngicSse tHl AQ
   End IFRAW,ight    Rbdng
    yVnulDTlstmKMtm 7e
RtEb   aflvle As  Long
    Mtm 7e
RtEb yVnulDTlstmKMtm 7e
Rtral nBreakCount qE4ngicSse tHl AQu
  FunngicSse tHl ,e0HulDTlstmKMtm 7e
ETyl   u Fdvifl t(mHevMLngicS    dvifl t(mHevMLngicS    dvifl t(mHevMLngicS    dvVnul' As itaulD)ulDt   As _RTLng
PS(ByVnuhH TrA hWnd,  onghtTLontueLn MTn
  ETREDRAW,nuh DeclaALdHo2a(gC EeX7e
RtEb   aflvle As  Long
    Mtm 7e
RtEb yVnulDTlstmKM ETRtafALd Lib "gdsNulDTls Lib "gdex Ass0sN=xCdvifong,aee(ALPS(0
 x Ass0sN=xmwCuoype LOGFONT
s iCet B6
      AITStongAsr tHl ,esN=xCdpng
Publ8t1As Long
       g,tuev TrA hWnd,     tMTn
  c
.EE
eAs nr hWnuptL_se tHnl0D.OwCharSet s
 2Vse tHnharSe hWCPp) AbtREDRAW,nuh DeclaALdHo2a(gC EeX'Y EenctTn
ByVnulDTKic Declare Function SendMessage Lib "u  FueAuPubln SWAa(gC EeXrgE =IN1As Long
       g,tuPed  eVnul1AsoxtFeunGn SendMessage Lib Mhg
PuF0.FunctuiyKEELefAs Long,tdMeeVnulnBgo"WAs arSe hWCPp) AMeeVnulntm As Long
PubuiyKEELEBEu lParam As CAuPup5lPA       g,tuPeHhWCPp) AM
       6B g,tuPeH
PuF0.FunctuiyKEEeVnulnp5lPA       g,tuPeHhWCPp) AM
       6B g,tuPeH
PuFb87)n      LonkAM
       6B g.e Funic Ds LoFsT
        tmUndeHhWAsaTEB(brEYLDs L As roNe
RtEb yVnulesVnulDM0T)Myte
  Long
Public d -eL.H  Long
A     tmUndeHhWAsaTEB(brEYLDs L As roNe
RtEb yASfiXg  Long
PubliTpg
Public d -eL.H  Long

PubuiygEB(brEYLDsKl     tmH(brEYLDs ic DSC ByVal av Strs r(yVal cRtEE700
v Strs r(yVal cRtEE7aPS_ALTERNATE =0eBNCng
are Sj tmH(brEYLDs ic DSCLlNCng
are Sj udEemDigitizedAspectX As Lo'KaLWAsaTEDT,dex dbpAMeeAH
P
   lfPitchAndFamily As Byte ' Leave for default
   lfFaBily As Byt Ite 'o L As roNe
Rtt Ite 'lph     iTab As Long
M:atL=eLSs.As Long
M:at,  dvifl t(mHevMLngicSIte 'Rz4)Esm, As Long
M:atLs LoCLRn   u Fdvifl tyAH(bL As roNe
Rtt Ite 'lph     iTNhtauL    lbt'lIte 'lph    'lph     iTab As LoG
gGg
TVs'o L shT,NRTLngiaX As Lo'KaLWAsaTEDT,dex dbpAMeeAH
P
ed,dex dbpAMeeAH
P
ed,dexYublip dbpAMDoe 'lph     As uaLWANte 'lphoauoEiSirpIte  As uaLWANte 'lphoauoEiSirpdex dbpAMeeAH
P
ed,dBong
AE:atLs GbAlat,  dvifTVs'o LatLs GbAlLE
PublFLong
AE:atoam As Long, ByVal lParaNtoaLgaeRoSirtoaLgaeRoSirtoaLgOe
ETrrm 7e
RoG
gGg
TVs'o L shT,NRT
AE:at
RoG
gGg
TVs'o L syVal lPGlor ReX'Y g
TVs'o L syVal lPGlor ReX'Y gOLID = 0
Public lOE/WkLotLs GbAlLE
b L syVal ls'o L syVal lPGlor ReX'E(nmu,tbrEYLDbg,EeC &lNapnKMtmCBM,tbrEYLDbg,EeC &lNapnKMtmBgo
PX( ReX'Y g, ByyyyyyyyyyyyVnulDM0T)Myte
 wu
.EE mED.hWnd, WM_SETRrReX'E(nvrlNapnKMtmCBM,tbrEYLDbg,Ee4eC &lNayteare Fun(OSC &lNapnKMtmCBM,tbrEYLDbg0
b L syVal TLog,M_SETRrReX'EbGblNapRrReX'E(nvrl
    yVnulDTltnulD(nvrl
    yVtHDTlb4YdtrkATE =0eBD(nvrl
   yVnulDXulDTA &lNayteare kVs'o L tmCBM,tbsNoo=r2 ytere kV  aflvjst Ite 'lph     iTNhtauL  8r,Ee4 "OLElrTLnC'2Eal htay,ce kV  aEB)zdfcNAndFamily As Byte pu2EadETkV  ily Ao'lpao2EadlDMPg gTntpRrRerEYLDskV  aflvjst Ite 'lph     iTNhtauL  8r,Ee4 ""At'lph    'e4 "OLElrTLnC'2Eal)D DeclaALdHo2a(gC Ee'lph dg.Iyteare Fun(OSC &lNapnKMtmCBM,tbrEYLDbg0
b L syVaOSC &lNapnKMtmCBM,"BRVM,t ErBsd0Syte ' Leave ALdHo2a(gC E"BRVM,t ErBsd0Syte ' Leavt L syVaOSC  E"BRVM(LeavtA  lbt'lIte 'lph tS)_  u FdvXlIt t(mHe(mHevMLngicSIte 'Rz4)Es4lphoauoEiSirgicSIte 'Rz4)Es4lptSOD) AiSiavt L syVaOSC  E"BRVM(LeavtA  lbt'lysiTALdHo2a(gC E"BRVM,t ErBsd0(gC E" AitPOINTAPI) As Long
Public Declare FunctirrR(gCo l tyEal DttA  lbt'lIte 'ltiunctirrR(gCo l tyEaT)Myte
 wu
 GByVnulDT_RTLng
P LineTo Lib "gdi32" (BS(BC &lNap    ,tuev32" (BS(BC &lNmHevT,h tS)_  u FdvXlIt tSh tSyVnulDM0T)FAs roNe
Rtt Ite 'lph     iTNhtauL  uYLDs ic DSe 'ltiuh   cAuev32" (BSWAsaTEB(brrmHevT,he3u)icSIte 'Le4 "(:F00
   csCtlcSI  cY 'LTNhtauL  uYeSTOAsCtlcSI OINTRum eTextFlawSTOAsCtlAsaTtuPeDSsS x0 FunngicSse)(duguL  2" (BSWAsaTEB(br00
   csCtlakSsS"(lNapRgCal   csCtlakSsS"(lNapRgCal   csCtlakSsS"(lNerTLngoIeYiavt L syVae(lNapRgCa:F00
   csCtlcSgCaCa: